//**********************************************************************
//*                                        *
//*           *
//*   "W"  "dB"   -2  -3   20   * 
//*  c  -1.5  -1.9   28    *
//*                     (C) ., 2016,2017                        *
//*                        V2.0  17.02.2016                          *
//*                        V2.1  05.06.2016                          *
//*                        V3.0  16.05.2017                          *
//*                        V4.0  11.07.2017                          *
//*                        V4.1  03.08.2017                          *
//*                        V4.2  04.08.2017                          *
//*                   AVR Studio V4.19 Build 730                       *
//**********************************************************************
//  (ATmega8)   : 8 
//Low Fuse:  64
//High Fuse: D1
//        .
// :
//PD1..PD4, PC5 (RS), PC4 (E), PD0 (RW) -  1602  4- 
//PC3 (ADC3) -     
//PC0 (ADC0) -     
//PB1 -     (   )
//PB2 -       / 
//PB6 -      (  > 4.0)
//PB5, PB4, PB3 -  "-", "Sel", "+"     

//  >4.0:       
//(  8  9 ),    ,     
// ,  Jmp1  ,    
// 28,      -1.5  (  Jmp2)   -1.9 
//(  Jmp2),      40.5   51.3 .


#include <avr/io.h>
#include <util/delay.h>
#include <avr/interrupt.h>
#include <avr/wdt.h>
#include <avr/eeprom.h>
#include <math.h>   // libm.a   Libraries   !
#include <stdlib.h> //  utoa



//----     ----

//===   
// 
#define lcd_RS_PORT PORTC
#define lcd_RS_DDR DDRC
#define lcd_RS PC5
#define lcd_E_PORT PORTC
#define lcd_E_DDR DDRC
#define lcd_E PC4
#define lcd_RW_PORT PORTD
#define lcd_RW_DDR DDRD
#define lcd_RW PD0
//  
#define lcd_DB4_PORT PORTD // 
#define lcd_DB5_PORT PORTD
#define lcd_DB6_PORT PORTD 
#define lcd_DB7_PORT PORTD 
#define lcd_DB4_PIN PIND   // 
#define lcd_DB5_PIN PIND
#define lcd_DB6_PIN PIND 
#define lcd_DB7_PIN PIND 
#define lcd_DB4_DDR DDRD   //  
#define lcd_DB5_DDR DDRD
#define lcd_DB6_DDR DDRD 
#define lcd_DB7_DDR DDRD
#define lcd_DB4 PD1        // 
#define lcd_DB5 PD2
#define lcd_DB6 PD3
#define lcd_DB7 PD4
#define lcd_delay 20       //  E  LCD, 


void set_lcd_DATA_PORT (unsigned d)
//     
{
lcd_DB4_PORT &= ~(1 << lcd_DB4); //    
lcd_DB5_PORT &= ~(1 << lcd_DB5);
lcd_DB6_PORT &= ~(1 << lcd_DB6);
lcd_DB7_PORT &= ~(1 << lcd_DB7);
lcd_DB4_PORT |= (((d >> 0) & 1) << lcd_DB4);
lcd_DB4_PORT |= (((d >> 1) & 1) << lcd_DB5);
lcd_DB4_PORT |= (((d >> 2) & 1) << lcd_DB6);
lcd_DB4_PORT |= (((d >> 3) & 1) << lcd_DB7);
}


void lcd_busy (void)
//    4- 
{
lcd_DB4_DDR &= ~(1 << lcd_DB4); //    
lcd_DB5_DDR &= ~(1 << lcd_DB5);
lcd_DB6_DDR &= ~(1 << lcd_DB6);
lcd_DB7_DDR &= ~(1 << lcd_DB7);
lcd_RS_PORT &= ~(1 << lcd_RS);  //RS = 0
lcd_RW_PORT |= (1 << lcd_RW);   //R/W = 1 - 
unsigned char flag = 1;
while (flag)
  {
  lcd_E_PORT  |= (1 << lcd_E);  //E = 1   -   
  _delay_us (lcd_delay);
  flag = ((lcd_DB7_PIN & (1 << lcd_DB7)) >> lcd_DB7);
  lcd_E_PORT &= ~(1 << lcd_E);  //E = 0
  _delay_us (lcd_delay);
  lcd_E_PORT  |= (1 << lcd_E);  //E = 1   -    
  _delay_us (lcd_delay);
  lcd_E_PORT &= ~(1 << lcd_E);  //E = 0
  _delay_us (lcd_delay);
  }
lcd_DB4_DDR |= (1 << lcd_DB4); //    
lcd_DB5_DDR |= (1 << lcd_DB5);
lcd_DB6_DDR |= (1 << lcd_DB6);
lcd_DB7_DDR |= (1 << lcd_DB7);
lcd_RW_PORT &= ~(1 << lcd_RW);
}


void lcd_com (unsigned char b)
//     4- 
{
lcd_busy ();
lcd_RS_PORT &= ~(1 << lcd_RS); //RS = 0 - 
lcd_RW_PORT &= ~(1 << lcd_RW); //R/W = 0 - 
set_lcd_DATA_PORT (b >> 4);    //  
lcd_E_PORT |= (1 << lcd_E);    //E = 1 -  
_delay_us (lcd_delay);
lcd_E_PORT &= ~(1 << lcd_E);   //E = 0 -    
_delay_us (lcd_delay);
set_lcd_DATA_PORT (b & 0x0F);  //  
lcd_E_PORT |= (1 << lcd_E);    //E = 1 -  
_delay_us (lcd_delay);
lcd_E_PORT &= ~(1 << lcd_E);   //E = 0 -    
}


void lcd_dat (unsigned char b)
//     4- 
{
lcd_busy ();
lcd_RS_PORT |= (1 << lcd_RS);  //RS = 1 - 
lcd_RW_PORT &= ~(1 << lcd_RW); //R/W = 0 - 
set_lcd_DATA_PORT (b >> 4);    //  
lcd_E_PORT |= (1 << lcd_E);    //E = 1 -  
_delay_us (lcd_delay);
lcd_E_PORT &= ~(1 << lcd_E);   //E = 0 -    
_delay_us (lcd_delay);
set_lcd_DATA_PORT (b & 0x0F);  //  
lcd_E_PORT |= (1 << lcd_E);    //E = 1 -  
_delay_us (lcd_delay);
lcd_E_PORT &= ~(1 << lcd_E);   //E = 0 -    
}


void lcd_clr (void)
//  
{
lcd_com (0x01); // 
_delay_ms(5);   //>= 1,5 ms
}


void lcd_ini (void)
//  
{
//    
lcd_RS_DDR |= (1 << lcd_RS);
lcd_E_DDR  |= (1 << lcd_E);
lcd_RW_DDR |= (1 << lcd_RW);
lcd_DB4_DDR |= (1 << lcd_DB4);
lcd_DB5_DDR |= (1 << lcd_DB5);
lcd_DB6_DDR |= (1 << lcd_DB6);
lcd_DB7_DDR |= (1 << lcd_DB7);
//
lcd_E_PORT &= ~(1 << lcd_E);
_delay_ms(50); //    > 40 ms
//   0x30    8-  
lcd_RS_PORT &= ~(1 << lcd_RS); //RS = 0 - 
lcd_RW_PORT &= ~(1 << lcd_RW); //R/W = 0 - 
set_lcd_DATA_PORT (0x03);
lcd_E_PORT |= (1 << lcd_E);
_delay_us (lcd_delay);
lcd_E_PORT &= ~(1 << lcd_E);   // 1- 
_delay_ms(5); // > 4,1 ms
lcd_E_PORT |= (1 << lcd_E);
_delay_us (lcd_delay);
lcd_E_PORT &= ~(1 << lcd_E);   // 2- 
_delay_us(150); // > 100 us
lcd_E_PORT |= (1 << lcd_E);
_delay_us (lcd_delay);
lcd_E_PORT &= ~(1 << lcd_E);   // 3- 
_delay_us (lcd_delay);
//    8- 
// 4-    0x20
set_lcd_DATA_PORT (0x02);
lcd_E_PORT |= (1 << lcd_E);
_delay_us (lcd_delay);
lcd_E_PORT &= ~(1 << lcd_E);
//    4- 
lcd_com (0x28); //4 , 2 
lcd_com (0x08); // 
lcd_clr ();     // 
lcd_com (0x02); //    Home
lcd_com (0x06); //  ;    - 
lcd_com (0x0C); // ,  
}


void lcd_cur (unsigned char row, unsigned char col)
//    row,  col,   0
{
unsigned char addr; // DDRAM (   )
addr = col;
if (row & 0b00000010) addr += 20;
if (row & 0b00000001) addr |= 0x40;
lcd_com (0x80 | addr); //   DDRAM
}


void lcd_str (char *str)
//    
{
unsigned int i = 0;
while (str[i])
   {
   char s = str[i++];
   lcd_dat (s);
   }
}



/*
unsigned char nibble_char (unsigned char b)
//   
{
b &= 0x0F; 
if (b < 10)
   return (b+48); //
else
   return (b+55); //
}


void lcd_hex_byte (unsigned char b)
//  b     
{
lcd_dat (nibble_char (b >> 4));
lcd_dat (nibble_char (b));
}


void lcd_hex_int (unsigned int i)
//  i     
{
lcd_hex_byte (i >> 8);
lcd_hex_byte (i);
}
*/



void lcd_usg (unsigned char n, const unsigned char *usg)
//    n     
{
lcd_com (0x40); //   CGRAM     0x00
for (unsigned char i=0; i < ((((n - 1) & 7) + 1) << 3); i++) // n*8  
	lcd_dat (usg[i]); //  CGRAM        CGRAM
lcd_com (0x80); //   DDRAM      
}

//    
#define rectang_r_sym 0x00 //    , ""
#define rectang_l_sym 0x01 //    , ""
#define rectang_sym   0x02 //   ,  ""
#define speaker_sym   0x03 //
#define micro_sym     0x04 // ""
#define select_sym    0x05 //  


//    ( 8   )
const unsigned char usr_sym_n = 6; //   
const unsigned char usr_sg[] = {0x03,0x03,0x03,0x03,0x03,0x03,0x03,0x00,  // 0x00 - " "
                                0x18,0x18,0x18,0x18,0x18,0x18,0x18,0x00,  // 0x01 - " "
                                0x1B,0x1B,0x1B,0x1B,0x1B,0x1B,0x1B,0x00,  // 0x02 - " "
                                0x01,0x03,0x1D,0x15,0x1D,0x03,0x01,0x00,  // 0x03 - ""
                                0x00,0x12,0x12,0x12,0x12,0x1D,0x10,0x10,  // 0x04 - ""
								0x01,0x05,0x09,0x1F,0x08,0x04,0x00,0x00}; // 0x05 - "Enter" 
								

//----     ----

//===   

#define ADC_L 3 //    (ADC3)
#define ADC_R 0 //    (ADC0)
#define ADC_ref (1 <<REFS1) | (1 << REFS0) //   +2,54V


void ADC_ini (void)
// 
{
ADCSRA = (1 << ADEN) | (1 << ADPS2) | (1 << ADPS1) | (1 << ADPS0);
ADMUX = ADC_ref; 
}


void ADC_delay (void)
//   
{
_delay_us (500);
}


void ADC_left (void)
//   
{
ADMUX = ADC_ref | ADC_L; 
}


void ADC_right (void)
//   
{
ADMUX = ADC_ref | ADC_R; 
}


void ADC_start (void)
// 
{
ADCSRA |= (1 << ADSC);
}


void ADC_stop (void)
// 
{
ADCSRA &= ~(1 << ADSC);
}


//----     ----

//     ,   
//  . ""        ,
//""   .       
//      .  
//         .

#define flag_3_jmp_PORT PORTB //    
#define flag_3_jmp_PIN  PINB
#define flag_3_jmp_DDR  DDRB
#define flag_3_jmp PB1
#define flag_W_jmp_PORT PORTB //     
#define flag_W_jmp_PIN  PINB
#define flag_W_jmp_DDR  DDRB
#define flag_W_jmp PB2
#define flag_NoVal_jmp_PORT PORTB //    
#define flag_NoVal_jmp_PIN PINB
#define flag_NoVal_jmp_DDR DDRB
#define flag_NoVal_jmp PB6
unsigned char noval_flag; // ,      

#define max_code 1023  //       U = 0..Vref
#define n1 20          //      
#define n2 28          //      
unsigned char n;       //n1  n2
#define F_clc 8            //  , 
#define T1_delay 100       //   T1, 
#define T1_preset (65536 - T1_delay * 256l / F_clc) //    T1
#define float_delay 1000   //  , 
#define float_count_max  float_delay / T1_delay //  T1    float_delay
unsigned int float_count_l = 0; //      
unsigned int float_count_r = 0; //      
unsigned char float_flag_l = 0; //     
unsigned char float_flag_r = 0; //     
unsigned char x_l = 0;  //  x     1..n; 0 - 
unsigned char x_r = 0;  //  x     1..n; 0 - 
unsigned char x1_l = 0; //  x    
unsigned char x1_r = 0; //  x    
unsigned float_x_l = 0; //   
unsigned float_x_r = 0; //   
unsigned int code_l = 0; //    
unsigned int code_r = 0; //    
unsigned char x0 = 2;    //     

//          -2  -3 
unsigned int level [2*n2];
//       -2  -3 
//  -   4 ;   -  
char power_val [2*(n1+1)][4];
//       -2  -3 
//  -   3 ;   -  
char db_val [2*(n1+1)][3];



unsigned char check_flag_3 (void)
//    -3 
{
return (!(flag_3_jmp_PIN & (1 << flag_3_jmp)));
}


unsigned char check_flag_W (void)
//      
{
return (!(flag_W_jmp_PIN & (1 << flag_W_jmp)));
}


unsigned char check_flag_NoVal (void)
//     
//      
{
return (!(flag_NoVal_jmp_PIN & (1 << flag_NoVal_jmp)));
}


void scale_ini ()
// 
{
lcd_clr ();
cli (); // 
x_l = 0; x_r = 0; x1_l = 0; x1_r = 0; float_x_l = 0; float_x_r = 0;
float_count_l = 0; float_count_r = 0; float_flag_l = 0; float_flag_r = 0;
sei ();  // 
//  
lcd_cur (0,0);
lcd_dat ('L');
lcd_dat (speaker_sym); //
lcd_cur (1,0);
lcd_dat ('R');
lcd_dat (speaker_sym);
flag_3_jmp_DDR  &= ~(1 << flag_3_jmp); //    
flag_3_jmp_PORT |=  (1 << flag_3_jmp);
flag_W_jmp_DDR  &= ~(1 << flag_W_jmp);
flag_W_jmp_PORT |=  (1 << flag_W_jmp);
flag_NoVal_jmp_DDR  &= ~(1 << flag_NoVal_jmp);
flag_NoVal_jmp_PORT |=  (1 << flag_NoVal_jmp);
}


void disp_float (unsigned char y, unsigned char x, unsigned char float_x)
//    float_x      (y,x)
//      2  
{
if (x < float_x) //      ,   
   {
   unsigned char x_lcd = (x+1) >> 1; //     
   unsigned char float_x_lcd = (float_x+1) >> 1; //    
   if (x_lcd < float_x_lcd) //        
	  {
      lcd_cur (y, x0+float_x_lcd-1);
	  if (float_x & 0x01) //    
	     lcd_dat (rectang_l_sym); // 
	  else   //    
         lcd_dat (rectang_r_sym); // 
	  }
   else
      if (x_lcd == float_x_lcd) //       
	     { //,    
         lcd_cur (y, x0+float_x_lcd-1);
	     if (float_x & 0x01) //    
	        lcd_dat (rectang_l_sym); // 
	     else   //    
            lcd_dat (rectang_sym);   // 
	     }		   
   }
}


void blank_float (unsigned char y, unsigned char x, unsigned char float_x)
//    float_x      (y,x)
//      2  
//     0,  -   1,  - 2
{
if (x < float_x) //      ,   
   {
   unsigned char x_lcd = (x+1) >> 1; //     
   unsigned char float_x_lcd = (float_x+1) >> 1; //    
   if (x_lcd < float_x_lcd) //        
	  {
      lcd_cur (y, x0+float_x_lcd-1);
      lcd_dat (' '); //  
	  }
   else
      if (x_lcd == float_x_lcd) //       
	     {
         lcd_cur (y, x0+float_x_lcd-1);
         lcd_dat (rectang_l_sym); //  -  ,  
	     }		   
   }
}


void disp_power (unsigned char y, unsigned char x)
//       y
//      x=0..n
//   ,   ,
// 5 ,   - 4 .
//    ,   !
{
char power_str[6]; //    
if (x > n) x = n;
unsigned char j = x;
if (check_flag_3 ())
   j += n+1; //    
if (check_flag_W ())
   { //W
   char * ptr = power_val [j];
   //     
   if (x < n-1)
      {
      for (unsigned char i = 0; i < 4; i++) power_str[i] = * ptr++; //4 
	  if (x > 0)
         power_str[4] = 'W'; //  "W",    
      else //   
         power_str[4] = ' ';
      power_str[5] = 0; //     
      lcd_cur (y, 11);
      }
   else //   
      {
      power_str[0] = * ptr++; //    1-  
      for (unsigned char i = 0; i < 3; i++) power_str[i] = * ptr++; //3 
	  power_str[3] = 'W'; //  "W"
      power_str[4] = 0; //     
      lcd_cur (y, 12);
      }
   }
else
   { //dB
   char * ptr = db_val [j];
   //     
   if (x < n-1)
      {
      for (unsigned char i = 0; i < 3; i++) power_str[i] = * ptr++; //3 
      if (x > 0)
	     {
         power_str[3] = 'd'; //  "dB",    
		 power_str[4] = 'B';
		 } 
      else //   
	     {
         power_str[3] = ' ';
		 power_str[4] = ' ' ;
		 }
      power_str[5] = 0; //     
      lcd_cur (y, 11);
      }
   else //   
      {
      power_str[0] = * ptr++; //    1-  
      for (unsigned char i = 0; i < 2; i++) power_str[i] = * ptr++; //2 
      power_str[2] = 'd';
      power_str[3] = 'B';
      power_str[4] = 0; //     
      lcd_cur (y, 12);
      }
   }
lcd_str (power_str);
}


unsigned char calc_pos (unsigned int code)
//  0..n       code=0..max_code
{
unsigned char i;
if (code > max_code) code = max_code;
//      
if (check_flag_3 ())
   for (i = 0; (i < n) && (level[i+n] <= code); i++);
else
   for (i = 0; (i < n) && (level[i] <= code); i++);
// i = 0,     ,
//   i  (i=1..n)
return (i);
}


unsigned char disp_pos (unsigned int code, unsigned char y1, unsigned char x1)
//    code 
// (y1,x1)    
//  -   x
{
unsigned char x = calc_pos (code); //  x  
signed char dx = x - x1; //  x  
unsigned char x_lcd = (x + 1) >> 1;   //      
unsigned char x1_lcd = (x1 + 1) >> 1; //      
signed char dx_lcd = x_lcd - x1_lcd;  //  x  
if (dx < 0) //     
   {
   if (dx_lcd < 0) //        
      {
	  lcd_cur (y1,x0+x_lcd);
      for (unsigned char j = 0; j < -dx_lcd; j++)
        { lcd_dat (' '); } // "" 
	  if (x & 0x01) //   x -  (  >= 1   x_lcd >= 1)
	     {
		 lcd_cur (y1,x0+x_lcd-1);
		 lcd_dat (rectang_l_sym); //     
	     }		  
	  }
   else
      if (dx_lcd == 0) //      
	     {
		 lcd_cur (y1,x0+x_lcd-1); // x_lcd = x1_lcd >= 1,   x1 >= 1
		 lcd_dat (rectang_l_sym); //     
	     }   
   }
else
   if (dx > 0) //    
      {
	  if (dx_lcd > 0) //        
	     {
			 if (x1 & 0x01) //   - ,     
			    {
				lcd_cur (y1,x0+x1_lcd-1); //x1_lcd >= 1,   x1    x1 >= 1
				lcd_dat (rectang_sym); //   
		        }
	     lcd_cur (y1,x0+x1_lcd);
	     for (unsigned char j = 0; j < dx_lcd; j++) 
	       { lcd_dat (rectang_sym); } //  
	     if (x & 0x01) //   - 
		    {
		    lcd_cur (y1,x0+x_lcd-1); // x_lcd >= 1,   x    x >= 1
		    lcd_dat (rectang_l_sym); //     
			}
         }
	  else
         if (dx_lcd == 0) //      
		    {
		    lcd_cur (y1,x0+x_lcd-1); // x_lcd >= 1,   dx > 0   x >= 1
		    lcd_dat (rectang_sym);   //     
		    }
	  }
return (x);
}



void timer1_start (void)
//  1
{
TCCR1B = 0; //  1
TCNT1 = T1_preset; //  T1  
TCCR1B |= (1 << CS12); //  1   256
}


void timer1_ini (void)
//  1
{
timer1_start ();
TIMSK  |= (1 << TOIE1); //     1
}


ISR (TIMER1_OVF_vect)
//===     16-  1
//        
{
float_count_l++; 
if (float_count_l > float_count_max)
   {
   float_count_l = 0;
   float_flag_l = 1; 
   }
float_count_r++;
if (float_count_r > float_count_max)
   {
   float_count_r = 0;
   float_flag_r = 1; 
   }
timer1_start ();
}




//----     ----

#define Pmax_0 100              //    , 
unsigned int Pmax = Pmax_0;     //  
uint16_t eeprom_Pmax EEMEM;     // Pmax  EEPROM
uint16_t eeprom_Pctr EEMEM;     //   Pmax



void read_eeprom (void)
//   EEPROM  Pmax
{
uint16_t p = eeprom_read_word (&eeprom_Pmax);
uint16_t c = eeprom_read_word (&eeprom_Pctr);
if (((p < 1) || (p > 999)) || ((p + 5) != c)) // 
   Pmax = Pmax_0;
else
   Pmax = p;
}


void write_eeprom (void)
//  EEPROM   Pmax
{
uint16_t p = Pmax;   //  Pmax
uint16_t c = Pmax+5; // 
eeprom_update_word (&eeprom_Pmax,p);
eeprom_busy_wait (); //     EEPROM
eeprom_update_word (&eeprom_Pctr,c);
eeprom_busy_wait (); //     EEPROM
}



void Pow2Str (double P, char * Buf)
//  Buf   4      P, 
{
char s[3]; //      < 1000
double rP;
Buf[0] = ' ';
rP = round (P);
if (rP > 999) //
   {
   Buf[1] = 'X';
   Buf[2] = 'X';
   Buf[3] = 'X';
   }
else
   {
   if (rP < 100) // 100 
      if (rP < 10) // 10 
	     {
		 P = P * 10;
		 rP = round (P);
         if (rP < 10)   // 1 
		    {
		    P = P * 10;
		    rP = round (P);
	        if (rP < 10)  // 100 
			    {
		        P = P * 10;
		        rP = round (P);
		        if (rP < 10)  // 10 
				   { 
		           P = P * 10;
		           rP = round (P);
			       if (rP < 10)  // 1 
				      {
		              P = P * 10;
		              rP = round (P);
				      if (rP < 10) // 100 
					     {
		                 P = P * 10;
		                 rP = round (P);
				         if (rP < 10) // 10 
				            {
					        utoa (rP,s,10); //0..9 
                            Buf[1] = ' ';
                            Buf[2] = s[0];
                            Buf[3] = micro_sym;
					        }
                         else //  10   100 
						    {
					        utoa (rP,s,10); //10..99 
                            Buf[1] = s[0];
                            Buf[2] = s[1];
                            Buf[3] = micro_sym;
							}
                         }
                      else //  100   1000 
					     {
					     utoa (10*round(P/10),s,10); //0,1..0,9  -    
                         Buf[0] = '0';
                         Buf[1] = '.';
                         Buf[2] = s[0];
                         Buf[3] = 'm';
						 }
                      }
                   else //  1   10 
				      {
				      utoa (rP,s,10); //1,0..9,9 
                      Buf[0] = s[0];
                      Buf[1] = '.';
                      Buf[2] = s[1];
                      Buf[3] = 'm';
					  }
                   }
                else //  10   100 
				   {
				   utoa (rP,s,10); //10..99 
                   Buf[1] = s[0];
                   Buf[2] = s[1];
                   Buf[3] = 'm';
				   }
               }
            else //  100   1000 
			   {
			   utoa (rP,s,10); //0,10..0,99 
			   Buf[0] = '0';
			   Buf[1] = '.';
               Buf[2] = s[0];
               Buf[3] = s[1];
			   }
            }
         else //  1   10 
		    {
			utoa (rP,s,10); //1,0..9,9 
            Buf[1] = s[0];
			Buf[2] = '.';
            Buf[3] = s[1];
			}
		 }
      else //  10   100 
	     {
		 utoa (rP,s,10); //10..99 
         Buf[1] = ' ';
		 Buf[2] = s[0];
         Buf[3] = s[1];
		 }
   else //  100   1000 
      {
	  utoa (rP,s,10); //100..999 
	  Buf[1] = s[0];
      Buf[2] = s[1];
      Buf[3] = s[2];
	  }
   }
}


void Db2Str (unsigned char D, char * Buf)
//  Buf   3     -D  
//  -      
{
char s[2]; //      < 100
Buf[0] = ' ';
if (D == 0)
   {
   Buf[1] = ' ';
   Buf[2] = '0'; 
   }
else
   if (D < 10)
      {
	  utoa (D,s,10);
	  Buf[1] = '-';
	  Buf[2] = s[0];
	  } 
   else
      if (D < 100)
	     {
	     utoa (D,s,10);
	     Buf[0] = '-';
	     Buf[1] = s[0];
	     Buf[2] = s[1];
	     }
      else
	     { //
		 Buf[0] = '-';
		 Buf[1] = 'X';
		 Buf[2] = 'X';
		 }
}


void tables_ini (void)
//  
//  Pmax=1..999    , 
{
double k2 = pow (10,2.0/20);  //     -2  (1.25...)
double k3 = pow (10,3.0/20);  //     -3  (1.41...)
double k15 = pow (10,1.5/20); //     -1.5 
double k19 = pow (10,1.9/20); //     -1.9 
double k2_2 = k2*k2;          // 
double k3_2 = k3*k3;
double k1_2, k1_3, p1_2, p1_3;
unsigned char d1_2, d1_3;
k1_2 = round (max_code);
k1_3 = k1_2;
d1_2 = 0;
d1_3 = 0;
p1_2 = round (Pmax);
p1_3 = p1_2;

if (!(noval_flag)) //   ; n=20
{ //##
//        
db_val [0][0] = ' '; db_val [0][1] = ' '; db_val [0][2] = ' '; 
db_val [n+1][0] = ' '; db_val [n+1][1] = ' '; db_val [n+1][2] = ' ';
power_val [0][0] = ' '; power_val [0][1] = ' '; power_val [0][2] = ' '; power_val [0][3] = ' ';
power_val [n+1][0] = ' '; power_val [n+1][1] = ' '; power_val [n+1][2] = ' '; power_val [n+1][3] = ' ';
for (unsigned char i=n; i>0; i--)
  {
  //           -2  -3 
  level[i-1]   = round (k1_2); //  -2 
  level[n+i-1] = round (k1_3); //  -3 
  k1_2 = k1_2 / k2;
  k1_3 = k1_3 / k3;
  } 
for (unsigned char i=n; i>0; i--)
  {
  //      
  Db2Str (d1_2, db_val [i]);
  Db2Str (d1_3, db_val [i+n+1]);
  d1_2 = d1_2 + 2;
  d1_3 = d1_3 + 3;
  //      
  //-         
  Pow2Str (p1_2, power_val [i]);
  Pow2Str (p1_3, power_val [i+n+1]);
  p1_2 = p1_2 / k2_2; //   i   (1..n)   -2 
  p1_3 = p1_3 / k3_2; //   i   (1..n)   -3 
  }
  if (Pmax == 1) //        5 : 0.50  0.63
     { //    
	 power_val [n-1][3] = power_val [n-1][2]; power_val [n-1][2] = power_val [n-1][1]; 
	 power_val [n-1][1] = power_val [n-1][0]; power_val [n-1][0] = ' ';
	 power_val [n+n][3] = power_val [n+n][2]; power_val [n+n][2] = power_val [n+n][1]; 
	 power_val [n+n][1] = power_val [n+n][0]; power_val [n+n][0] = ' ';
	 }
} //##
else
//    :    -1.5 / 2      n=28
{ //@@
for (unsigned char i=n; i>0; i--)
  {
  //           -1.5  -1.9 
  level[i-1]   = round (k1_2); //  -1.5 
  level[n+i-1] = round (k1_3); //  -1.9 
  k1_2 = k1_2 / k15;
  k1_3 = k1_3 / k19;
  } 
} //@@
}



//----     ----

//===   

#define but_minus_PORT PORTB
#define but_minus_PIN PINB
#define but_minus_DDR DDRB
#define but_minus PB5
#define but_plus_PORT PORTB
#define but_plus_PIN PINB
#define but_plus_DDR DDRB
#define but_plus PB3
#define but_select_PORT PORTB
#define but_select_PIN PINB
#define but_select_DDR DDRB
#define but_select PB4


#define change_val_delay 100   //    Pmax  -  +, 
#define key_pressed_delay 10   //    , 
#define key_check_count 5      //   
#define menu_select_delay 1000 //       , 
#define T0_ovf_delay  256l * (1024l / F_clc)  //     0, 
#define T0_ovf_count_max  menu_select_delay * 1000l / (T0_ovf_delay * 1l) // 
volatile unsigned char T0_ovf_count = 0; // 
volatile unsigned char select_long_press = 0; //    



void buttons_ini (void)
//   
{
but_minus_DDR   &= ~(1 << but_minus); //    
but_minus_PORT  |=  (1 << but_minus); //  
but_plus_DDR    &= ~(1 << but_plus);
but_plus_PORT   |=  (1 << but_plus);
but_select_DDR  &= ~(1 << but_select);
but_select_PORT |=  (1 << but_select);
}


unsigned char minus_pressed (void)
//   ""
{
return (!(but_minus_PIN & (1 << but_minus)));
}


unsigned char plus_pressed (void)
//   ""
{
return (!(but_plus_PIN & (1 << but_plus)));
}


unsigned char select_pressed (void)
//   ""
{
return (!(but_select_PIN & (1 << but_select)));
}


unsigned char minus_pressed_safe (void)
//""    ""  
{
unsigned char cycle = key_check_count; //   
while ((minus_pressed ()) && cycle)
  {
  _delay_ms (key_pressed_delay); //
  cycle--;
  }
return (cycle==0);
}


unsigned char plus_pressed_safe (void)
//""    ""  
{
unsigned char cycle = key_check_count;
while ((plus_pressed ()) && cycle)
  {
  _delay_ms (key_pressed_delay); 
  cycle--;
  }
return (cycle==0);
}


unsigned char select_pressed_safe (void)
//""    ""    
{
unsigned char res = select_long_press; //    
select_long_press = 0; //   ,   
return (res);
}


/*
unsigned char select_pressed_safe (void)
//""    ""  
{
unsigned char cycle = key_check_count;
while ((select_pressed ()) && cycle)
  {
  _delay_ms (key_pressed_delay); 
  cycle--;
  }
return (cycle==0);
}
*/



void timer0_start (void)
//  0
{
TCCR0 = 0;
TCNT0 = 0;
TCCR0 |= (1 << CS02) | (1 << CS00); //  0   1024
}


void timer0_ini (void)
//  0
{
timer0_start ();
TIMSK  |= (1 << TOIE0); //     0
}


ISR (TIMER0_OVF_vect)
//===     8-  0
//          
{
if (select_pressed ()) //  ""
   {
   T0_ovf_count++;
   if (T0_ovf_count > T0_ovf_count_max) // 
      {
      T0_ovf_count = 0;
      select_long_press = 1;
	  }
   }
else
   {
   T0_ovf_count = 0;
   select_long_press = 0;
   }
}


void pause (unsigned char dT)
// dT     
{
if ((dT > 0) && (dT < 25))
   for (unsigned char i=0; i<dT*10; i++) // 1 
      { wdt_reset (); _delay_ms (100); }
}


void out_Pmax_title (void)
//   Pmax
{
lcd_clr ();
lcd_cur (0,2);
lcd_dat ('P'); lcd_dat ('m'); lcd_dat ('a'); lcd_dat ('x'); lcd_dat (' '); lcd_dat ('=');
}


void out_menu (void)
//  
{
lcd_cur (1,2);
lcd_dat ('P');
lcd_dat ('r');
lcd_dat ('e');
lcd_dat ('s');
lcd_dat ('s');
lcd_dat (':');
lcd_dat (' ');
lcd_dat ('-');
lcd_dat (' ');
lcd_dat (select_sym);
lcd_dat (' ');
lcd_dat ('+');
}


void out_canceled (void)
//    
{
lcd_clr ();
lcd_cur (0,4);
lcd_dat ('C'); lcd_dat ('a'); lcd_dat ('n'); lcd_dat ('c'); lcd_dat ('e');
lcd_dat ('l'); lcd_dat ('e'); lcd_dat ('d'); lcd_dat ('!'); 
}


void out_Pmax (unsigned int Pmax)
//  Pmax = 1..999 W
{
char s[5]; // 
if ((Pmax < 1) || (Pmax > 999))
   Pmax = 999;
utoa (Pmax,s,10);
unsigned char l = floor (log10 (Pmax))+1; // 
if (l > 3) l = 3;
s [l] = 'W';
s [l+1] = 0; // 
lcd_cur (0,10);
lcd_str (s);
}



void Pmax_change (void)
//   Pmax
{
cli (); // 
unsigned int P = Pmax; //  Pmax
out_Pmax_title ();
out_Pmax (P);
out_menu ();
lcd_com (0x0D); //    
lcd_cur (0,10);
while (select_pressed ()) { wdt_reset (); } //  
unsigned char cancel = 0; //    Pmax
sei (); //      
//   Pmax   
while ( (!(select_pressed_safe())) && (!cancel) )
  {
  if (minus_pressed_safe ())
	 {
	 if ( (plus_pressed ()) || (select_pressed ()) ) // -    
		cancel = 1;
     else
	    {
		cli ();
		if (P > 1) P = P - 1;
	    lcd_cur (0,10); lcd_dat (' '); lcd_dat(' '); lcd_dat (' '); lcd_dat(' ');
	    out_Pmax (P);
	    lcd_cur (0,10);
		_delay_ms (change_val_delay);
		sei ();
		}
	 }
  if (plus_pressed_safe ())
	 {
	 if ( (minus_pressed ()) || (select_pressed ()) ) // -    
		cancel = 1;
     else
	    {
		cli ();
		if (P < 999) P = P + 1;
	    out_Pmax (P);
	    lcd_cur (0,10);
		_delay_ms (change_val_delay);
		sei ();
		}
     }
  wdt_reset ();
  } //  
cli (); // 
//  Pmax 
lcd_com (0x0C); //    
if (cancel)
   out_canceled (); // -  
else
   {
   Pmax = P;
   write_eeprom ();   //   Pmax  
   tables_ini ();     // 
   out_Pmax_title ();
   out_Pmax (Pmax);   //   Pmax   
   lcd_dat (' '); lcd_dat ('!');
   }
while (select_pressed ()) { wdt_reset (); } //  
pause (1);    // 1 
scale_ini (); //    
sei (); // 
}




//========================================================
int main (void)
{

noval_flag = check_flag_NoVal (); //     
if (noval_flag)  n = n2; else n = n1;

wdt_enable (WDTO_250MS); //  
ADC_ini ();     // 
lcd_ini ();     // 
lcd_usg (usr_sym_n, usr_sg); //   
read_eeprom (); //  Pmax  EEPROM
tables_ini ();  //   Pmax
buttons_ini (); // 
timer0_ini ();  //  0
timer1_ini ();  //  1
if (check_flag_W () && !(noval_flag))
   { //    
   out_Pmax_title ();
   lcd_cur (0,10);
   out_Pmax (Pmax);
   pause (2);    //   Pmax (  wdt)
   scale_ini (); //   
   }
else
   {
   scale_ini (); //   
   pause (1);    //     (  wdt)
   }



while (1) 
   {

   //       
   ADC_left ();   //    
   ADC_start ();  //     
   ADC_delay ();  //  
   ADC_stop ();   // 
   code_l = ADC;  //    
   ADC_right ();  //    
   ADC_start ();  //     
   ADC_delay ();  //  
   ADC_stop ();   // 
   code_r = ADC;  //    
   
   cli (); //     

   //      
   x_l = disp_pos (code_l, 0, x1_l); // 
   x_r = disp_pos (code_r, 1, x1_r);
   x1_l = x_l; x1_r = x_r; //  


   //       
   if (x_l > float_x_l) //   
      {
	  float_count_l = 0; //    
	  float_flag_l = 0;
      //    
	  if (!(noval_flag)) disp_power (0, x_l);
	  //    (      )
	  float_x_l = x_l;
	  }
   else
      if (x_l < float_x_l) //   
	     {
         if (float_flag_l) //   
            {
			float_count_l = 0;  //    
			float_flag_l = 0;
           //       
            blank_float (0, x_l, float_x_l);
            if (!(noval_flag)) disp_power (0, x_l);
	        //    (      )
	        float_x_l = x_l;
			}
         else
			//  ,       
            disp_float (0, x_l, float_x_l);
		 }

   //       
   if (x_r > float_x_r) //   
      {
	  float_count_r = 0; //    
	  float_flag_r = 0;
      //    
	  if (!(noval_flag)) disp_power (1, x_r);
	  //    (      )
	  float_x_r = x_r;
	  }
   else
      if (x_r < float_x_r) //   
	     {
         if (float_flag_r) //   
            {
			float_count_r = 0; //    
			float_flag_r = 0;
            //       
            blank_float (1, x_r, float_x_r);
            if (!(noval_flag)) disp_power (1, x_r);
	        //    (      )
	        float_x_r = x_r;
			}
         else
			//  ,       
            disp_float (1, x_r, float_x_r);
		 }

   sei (); // 

   //       Pmax
   if (select_pressed_safe() && !(noval_flag)) //  
      Pmax_change (); //    Pmax

   _delay_ms(20); //       
   wdt_reset ();  //  

   } //while (1)

}
